require "dry/cli"

module NeoGruby
  module Sequel
    module CLI
      class Migrate < Dry::CLI::Command
        desc "Run database migration"

        argument :version, type: :string, desc: "Informe the migration name to destination"

        def call(version: nil, **)
          require './config/boot'
          require 'sequel'
          require 'yaml'

          ::Sequel.extension :migration

          config = YAML.load_file(NeoGruby.root.join('config', 'database.yml'))
          config[NeoGruby.env].keys.each do |name|
            dir = NeoGruby.root.join('db/migrations', name)
            puts dir if File.directory? dir
            ::Sequel::Migrator.run(NeoGruby.db[name.to_sym], dir, target: version) if File.directory? dir
          end
        end
      end

      register "sequel" do |prefix|
        prefix.register "migrate", Db::Migrate
      end
    end
  end
end
